#ifndef TAPIS
#define TAPIS
//------------------------------------------------------------------------------
#include "Atom.h"

#define ROUGE 0
#define VERTE 1
#define BLEUE 2
#define JAUNE 3
#define CYAN  4
#define MAUVE 5

#define NORTH 1
#define EAST  2
#define SOUTH 3
#define WEST  4

#define AVANT   1
#define ARRIERE 2
#define EXT     3
#define INT     4
#define DROIT   5
//------------------------------------------------------------------------------
class Tapis : public API::Molecule
  {
  private:
    int longueur;
    int largeur;
    int numAtomes;

    int directionCourante;

    API::Atom *atoms;
    int* mapping;

    
    void etape1();
    void etape2();
    void etape3();
    void etape4();
    
    int calcNez();
  protected:

  public:
    Tapis(int aLongueur, int aLargeur);
    ~Tapis();

    void init();

    void setDirection(int aDirection); //NORTH EAST SOUTH WEST
    int getDirection();

    void marche();
    
    //Normalement en private...
    void metPatte(int aNumAtome, int aNumPatte, int aMvt);  //AVANT ARRIERE EXT INT DROIT
  };
//------------------------------------------------------------------------------
#endif
