#!/bin/bash
# $Id: make_pi2a14_distrib.sh Exp $
#
# Author : Michel Dubois
#

version=0.2

if [ -z ${SIMATOMHOME} ]; then
        # IUP de Vannes
        #basedir=/home/etud/projets/lsir01/prosir4

	#Yann Le Guyadec
	#basedir=/usr/local/produits

	#IUT de Vannes
	#basedir=/usr/local/alt/produits

	#Michel DUBOIS
	basedir=/home/simulatom

	cd ${basedir}/simulatom-${version}
	source setup.bash
fi
${SIMATOMHOME}/.outil/make_pi2a14_clean.sh
cd $SIMATOMHOME/..
rm .outil/*~
tar -cvf pi2a14-${version}.tar simulatom-${version}/.outil/Makefile*.orig
tar -uvf pi2a14-${version}.tar simulatom-${version}/.outil/Makefile*.pi2a14
tar -uvf pi2a14-${version}.tar simulatom-${version}/.outil/make_pi2a14*
tar -uvf pi2a14-${version}.tar simulatom-${version}/README.pi2a14
tar -uvf pi2a14-${version}.tar simulatom-${version}/include/pi2a14
tar -uvf pi2a14-${version}.tar simulatom-${version}/src/pi2a14
tar -uvf pi2a14-${version}.tar simulatom-${version}/src/control/Makefile
tar -uvf pi2a14-${version}.tar simulatom-${version}/src/control/pi2a14*.cpp
tar -uvf pi2a14-${version}.tar simulatom-${version}/Makefile
gzip pi2a14-${version}.tar
