#ifndef CRUSTY_H
#define CRUSTY_H

#include "Molecule.h"

class Crusty : API::Molecule
{
 private:
  API::Atom *crusty;
  int etape;
  int typeMove;
  unsigned int syncIndex;
  int temp[3];// pour la fonction whatLegs(atom)...
  int left;// dsigntion des numro des pattes gauche et droite au sol pour la marche
  int right;//...id 
  int hautRight;
  int hautLeft;
  int avantLeft;//variables pour les "setTargetPosition(...)", gestion des orientations servoMotor
  int avantRight;
  int arriereLeft;
  int arriereRight;

  
 public:
  Crusty();
  ~Crusty();
  void initStruct();
  void changeBase1();
  void changeBase2();
  bool patteIsMoving(API::Atom * atome, int patteNumber);
  bool isMoving(API::Atom * atome);
  bool isStopped(API::Atom * atome, int nbrAtome);
  void checkSynchro();
  int * whatLegs(API::Atom * atome);
  void move (int Xdepart, int Ydepart, int Xarrive, int Yarrive, API::Atom * atome, int patteNumber);
  void walk();
  void walkStepOne(int legLeft, int legRight);
  void walkStepTwo(int legLeft, int legRight);
  void turnRight();
  void turnDownForUp();
  void turnReplace();
  void turnBack1();
  void turnBack2();
  void turnReload();

};
#endif

